//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.1-833 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2013.02.01 at 06:27:34 PM CET 
//


package nl.cloudfarming.client.isobus.model;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.HexBinaryAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * 
 * Type: Task data
 * 
 * Description:
 * 
 * The DataLogTrigger XML element is included in the task and contains the information about which
 * ProcessDataVariables values shall be logged as DataLogValues during task processing. The reference to the
 * DeviceElement can be added on the mobile system, as soon as a device is allocated to the task. When the
 * reference to the DeviceElement is already given at FMIS then a specific device was planned for the task. The
 * attributes of the DataLogTrigger define the behaviour of the task controller, regarding how to collect and store
 * the ProcessDataVariable values.
 * The data log methods 'time interval', 'distance interval' and 'on change' can be used in any combination. The
 * logging is triggered by the event that occurs first, and all active methods of these three data log methods are
 * then restarted. Additionally, the 'threshold limits' method can be added. With this addition, the logging is
 * triggered when the logging value enters the value range specified by the threshold limit definitions and is
 * enabled as long as the value is within the value range specified by the threshold limit definitions.
 * If the DataLogThresholdMinimum is smaller than the DataLogThresholdMaximum, data logging is enabled
 * when the value is between the DataLogThresholdMinimum and the DataLogThresholdMaximum. If the
 * DataLogThresholdMinimum is larger than the DataLogThresholdMaximum, data logging is enabled when the
 * value is larger than the DataLogThresholdMinimum or smaller than the DataLogThresholdMaximum.
 * The data log method 'total' is independent of the other data log methods and can be used with any
 * combination described above. DataLogValues of the type 'total' shall be stored once per task in the data
 * transfer file.
 * A maximum of 10 messages per process data variable per second can be transmitted by a device.
 * Values from parameter groups can be logged by specification of the attributes DataLogPGN,
 * DataLogPGNStartBit and DataLogPGNStopBit. When these attributes are specified, the DataLogDDI attribute
 * shall be set to 0xDFFE (PGN log value).
 * 
 * Included by XML elements:
 * 
 * - Task
 * References XML elements:
 * 
 * - DeviceElement
 *             
 * 
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "")
@XmlRootElement(name = "DLT")
public class DataLog {

    @XmlAttribute(name = "A", required = true)
    @XmlJavaTypeAdapter(HexBinaryAdapter.class)
    protected byte[] ddi;
    @XmlAttribute(name = "B", required = true)
    protected short method;
    @XmlAttribute(name = "C")
    protected Integer distanceInterval;
    @XmlAttribute(name = "D")
    protected Integer timeInterval;
    @XmlAttribute(name = "E")
    protected Integer thresholdMinimun;
    @XmlAttribute(name = "F")
    protected Integer thresholdMaximum;
    @XmlAttribute(name = "G")
    protected Integer thresholdChange;
    @XmlAttribute(name = "H")
    @XmlIDREF
    protected Object deviceElementId;
    @XmlAttribute(name = "I")
    @XmlIDREF
    protected Object valuePresentationId;
    @XmlAttribute(name = "J")
    protected Integer parameterGroup;
    @XmlAttribute(name = "K")
    protected Short parameterGroupStartBit;
    @XmlAttribute(name = "L")
    protected Short parameterGroupEndBit;

    /**
     * 
     * Unique number, which identifies
     * Gets the value of the DDI property.
     * the ProcessDataVariable (as specified in ISO 11783-11)
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public byte[] getDDI() {
        return ddi;
    }

    /**
     * Sets the value of the ddi property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDDI(byte[] value) {
        this.ddi = ((byte[]) value);
    }

    /**
     * 
     * Gets the value of the method property.
     * Selection of the log method:
     *  1 = time interval
     *  2 = distance interval
     *  4 = threshold limits
     *  8 = on change
     *  16 = total
     *                     
     * 
     */
    public short getMethod() {
        return method;
    }

    /**
     * Sets the value of the method property.
     * 
     */
    public void setMethod(short value) {
        this.method = value;
    }

    /**
     * 
     * Gets the value of the distanceInterval property.
     * Distance interval for data log in mm, 0 stops measurement.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getDistanceInterval() {
        return distanceInterval;
    }

    /**
     * Sets the value of the distanceInterval property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setDistanceInterval(Integer value) {
        this.distanceInterval = value;
    }

    /**
     * 
     * Gets the value of the timeInterval property.
     * Time interval for data log in ms, 0 stops measurement, 10 ms is minimum time interval.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getTimeInterval() {
        return timeInterval;
    }

    /**
     * Sets the value of the timeInterval property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setTimeInterval(Integer value) {
        this.timeInterval = value;
    }

    /**
     * 
     * Gets the value of the thresholdMinimun property.
     * Minimum threshold to activate the data log.
     * Threshold limit value is included in the value range to log. (231−1) stops measurement.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getThresholdMinimun() {
        return thresholdMinimun;
    }

    /**
     * Sets the value of the thresholdMinimun property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setThresholdMinimun(Integer value) {
        this.thresholdMinimun = value;
    }

    /**
     * 
     * Gets the value of the thresholdMaximum property.
     * Maximum threshold to activate the data log.
     * Threshold limit value is included in the value range to log. (−231+1) stops measurement.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getThresholdMaximum() {
        return thresholdMaximum;
    }

    /**
     * Sets the value of the thresholdMaximum property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setThresholdMaximum(Integer value) {
        this.thresholdMaximum = value;
    }

    /**
     * 
     * Gets the value of the thresholdChange property.
     * Change threshold to activate the data log, 0 stops measurement, 1 logs each change.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getThresholdChange() {
        return thresholdChange;
    }

    /**
     * Sets the value of the thresholdChange property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setThresholdChange(Integer value) {
        this.thresholdChange = value;
    }

    /**
     * 
     * Gets the value of the deviceElementId property.
     * Reference to XML element DeviceElement 
     * Format (DET|DET-)([0-9])+
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getDeviceElementId() {
        return deviceElementId;
    }

    /**
     * Sets the value of the deviceElementId property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setDeviceElementId(Object value) {
        this.deviceElementId = value;
    }

    /**
     * 
     * Gets the value of the valuePresentationId property.
     * Reference to XML element ValuePresentation
     * Format (VPN|VPN-)([0-9])+
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getValuePresentationId() {
        return valuePresentationId;
    }

    /**
     * Sets the value of the valuePresentationId property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setValuePresentationId(Object value) {
        this.valuePresentationId = value;
    }

    /**
     * 
     * Gets the value of the parameterGroup property.
     * Parameter Group to log a value from.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getParameterGroup() {
        return parameterGroup;
    }

    /**
     * Sets the value of the parameterGroup property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setParameterGroup(Integer value) {
        this.parameterGroup = value;
    }

    /**
     * 
     * Gets the value of the parameterGroupStartBit property.
     * First bit of the value to log from a parameter group. 
     * Bit 0 is the least significant bit of Byte 1 in the data field of a data frame.
     * The start bit is included in the value and becomes the least significant bit.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getParameterGroupStartBit() {
        return parameterGroupStartBit;
    }

    /**
     * Sets the value of the parameterGroupStartBit property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setParameterGroupStartBit(Short value) {
        this.parameterGroupStartBit = value;
    }

    /**
     * 
     * Gets the value of the parameterGroupEndBit property.
     * Stop bit of the value to log from a parameter group. 
     * The stop bit is included in the value and becomes the most significant bit.
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getParameterGroupEndBit() {
        return parameterGroupEndBit;
    }

    /**
     * Sets the value of the parameterGroupEndBit property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setParameterGroupEndBit(Short value) {
        this.parameterGroupEndBit = value;
    }

}
