//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.1-833 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2013.02.01 at 06:27:34 PM CET 
//


package nl.cloudfarming.client.isobus.model;

import java.math.BigDecimal;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * 
 * Type: Task data
 * 
 * Description:
 * 
 * The Grid XML element describes the dimension and position of a set of gridcells. There shall be a definition of
 * the minimum north/east position, the size of each gridcell and the number of gridcells in the north/east
 * direction. There can only be a single grid specified per task. The grid is always related to a partfield but the
 * definition of grid is always task-specific. The grid cells of a grid contain a reference to a TreatmentZone or a
 * process data variable value. The grid shall be specified as a complete array of gridcells in ascending order, as
 * gridcells do not contain any ordering information.
 * The gridcells shall be defined in a binary format in a separate file external to the XML data transfer file. There
 * can only be a single binary file per grid and per task. The gridcell files shall exist in the same folder as the data
 * transfer file. The name of the gridcell files shall be unique over all grids referred to by tasks of a data transfer
 * file.
 * 
 * References XML element:
 * - TreatmentZone
 * 
 * Included by XML elements:
 * - Task       
 *             
 * 
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "")
@XmlRootElement(name = "GRD")
public class IsobusGrid {

    @XmlAttribute(name = "A", required = true)
    @XmlJavaTypeAdapter(Adapter1 .class)
    protected BigDecimal minimumNorthPosition;
    @XmlAttribute(name = "B", required = true)
    @XmlJavaTypeAdapter(Adapter2 .class)
    protected BigDecimal minimumEastPosition;
    @XmlAttribute(name = "C", required = true)
    @XmlJavaTypeAdapter(Adapter3 .class)
    protected Double cellNorthSize;
    @XmlAttribute(name = "D", required = true)
    @XmlJavaTypeAdapter(Adapter4 .class)
    protected Double cellEastSize;
    @XmlAttribute(name = "E", required = true)
    protected long maximumColumn;
    @XmlAttribute(name = "F", required = true)
    protected long maximumRow;
    @XmlAttribute(name = "G", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlID
    protected String filename;
    @XmlAttribute(name = "H")
    protected Long filelength;
    @XmlAttribute(name = "I", required = true)
    protected GridTypeEnum type;
    @XmlAttribute(name = "J")
    protected Short treatmentZoneCode;

    /**
     * 
     * Gets the value of the minimumNorthPosition property.
     * Minimum north position of the grid Format: WGS84
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public BigDecimal getMinimumNorthPosition() {
        return minimumNorthPosition;
    }

    /**
     * Sets the value of the minimumNorthPosition property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMinimumNorthPosition(BigDecimal value) {
        this.minimumNorthPosition = value;
    }

    /**
     * 
     * Gets the value of the minimumEastPosition property.
     * Minimum east position of the grid Format: WGS84
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public BigDecimal getMinimumEastPosition() {
        return minimumEastPosition;
    }

    /**
     * Sets the value of the minimumEastPosition property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMinimumEastPosition(BigDecimal value) {
        this.minimumEastPosition = value;
    }

    /**
     * 
     * Gets the value of the cellNorthSize property.
     * North direction gridcell size Format: WGS84
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Double getCellNorthSize() {
        return cellNorthSize;
    }

    /**
     * Sets the value of the cellNorthSize property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCellNorthSize(Double value) {
        this.cellNorthSize = value;
    }

    /**
     * 
     * Gets the value of the cellEastSize property.
     * East direction gridcell size Format: WGS84
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Double getCellEastSize() {
        return cellEastSize;
    }

    /**
     * Sets the value of the cellEastSize property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCellEastSize(Double value) {
        this.cellEastSize = value;
    }

    /**
     * 
     * Gets the value of the maximumColumn property.
     * Number of the gridcells in east direction
     *                     
     * 
     */
    public long getMaximumColumn() {
        return maximumColumn;
    }

    /**
     * Sets the value of the maximumColumn property.
     * 
     */
    public void setMaximumColumn(long value) {
        this.maximumColumn = value;
    }

    /**
     * 
     * Gets the value of the maximumRow property.
     * Number of the gridcells in north direction
     *                     
     * 
     */
    public long getMaximumRow() {
        return maximumRow;
    }

    /**
     * Sets the value of the maximumRow property.
     * 
     */
    public void setMaximumRow(long value) {
        this.maximumRow = value;
    }

    /**
     * 
     * Gets the value of the filename property.
     * Unique name of gridcell file
     * Format: GRD[0-9][0-9][0-9][0-9][0-9]
     *                     
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFilename() {
        return filename;
    }

    /**
     * Sets the value of the filename property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFilename(String value) {
        this.filename = value;
    }

    /**
     * 
     * Gets the value of the filelength property.
     * Length of gridcell file in number of bytes
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Long }
     *     
     */
    public Long getFilelength() {
        return filelength;
    }

    /**
     * Sets the value of the filelength property.
     * 
     * @param value
     *     allowed object is
     *     {@link Long }
     *     
     */
    public void setFilelength(Long value) {
        this.filelength = value;
    }

    /**
     * 
     * Gets the value of the type property.
     * Grid type specification:
     *  1 = grid type 1
     *  2 = grid type 2
     *                     
     * 
     * @return
     *     possible object is
     *     {@link GridTypeEnum }
     *     
     */
    public GridTypeEnum getType() {
        return type;
    }

    /**
     * Sets the value of the type property.
     * 
     * @param value
     *     allowed object is
     *     {@link GridTypeEnum }
     *     
     */
    public void setType(GridTypeEnum value) {
        this.type = value;
    }

    /**
     * 
     * Gets the value of the treatmentZoneCode property.
     * Grid type 2 TreatmentZoneCode
     *                     
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getTreatmentZoneCode() {
        return treatmentZoneCode;
    }

    /**
     * Sets the value of the treatmentZoneCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setTreatmentZoneCode(Short value) {
        this.treatmentZoneCode = value;
    }

}
